{
                             Opus 1.1x Jmodem File Transfer Protocol Interface
                                written by Christopher L. Browne for Opus sysops

            This program and it's source has been released to the public domain!
}

{$M 8192,0,0}

Uses Dos,StrnTTT5;

var
  port, fname   : string;
  mode          : char;
  jctl, jlog    : text;

  munge, chomp    : string;


procedure parm;
{
    Parse out all the needed file path information.
}
var
  pstr : string;
  task, x : integer;
  plist :text;

begin
  assign(plist,'c:\tp\source\opus\jmo.prm');
  {$I-}  rewrite (plist);   {$I+}
  for x := 0 to paramcount do
    writeln(plist,paramstr(x));
  close(plist);
  writeln;
  pstr := paramstr(7);
  assign(jctl,pstr);
  {$I-} reset(jctl); {$I-}
  if ioresult <> 0 then
    halt(1);
  munge := copy(pstr,1,length(pstr)-4);
  chomp := munge + '.LOG';
  writeln('Using ',chomp,' as LOG file...');
  assign(jlog,chomp);
  {$I-} rewrite(jlog); {$I-}
  if ioresult <> 0 then
    halt(1);
end;

procedure read_ctl;
{
    This needs to be revamped for the possibility of a batch protocol.
}
begin
  while(not(eof(jctl))) do
  begin
    readln(jctl,munge);
    if munge[1] = 'P' then
    begin
      chomp := extractwords(2,1,munge);
      port := chomp;
    end;
    if munge[1] = 'S' then
    begin
      chomp := extractwords(2,1,munge);
      fname := chomp;
      mode := 'S';
    end;
        if munge[1] = 'G' then
    begin
      chomp := extractwords(2,1,munge);
      fname := chomp;
      mode := 'R';
    end;
  end;
  close(jctl);
end;

procedure jmlog(m : char; f : string);
{
    Opus will look for a .LOG file in the directory where the interface resides.
    This log file should be written ONLY if the xfer was successful and should
    contain "Sent|Got drive:full-path\filename.ext filesize". If found, Opus will
    read it and update the user's upload/download ratio appropriately.
}
var
  fr : searchrec;
begin
  case m of
    'S' : munge := 'Sent ';
    'R' : munge := 'Got ';
  end;
  findfirst(f,Anyfile,fr);
  chomp := int_to_str(fr.size);
  munge := munge + f + ' ' + chomp;
  writeln(jlog,munge);
end;

procedure test_exec;
{
    Put here for debug porpoise's but it looks good too!
}
begin
  writeln;
  writeln('Jmodem being called with command line...');
  writeln('jm.exe ' + mode + port + ' ' + fname);
end;

procedure jm;
{
    Run the protocol driver!
}
var
  jmret : word;
begin
  swapvectors;
    exec('jm.exe',mode + port + ' ' + fname);
  test_exec;
  jmret := DOSexitcode;
  swapvectors;
  if jmret = 0 then
    jmlog(mode,fname);
  close(jlog);
end;

{
    The program!
}
begin
  writeln('Jmodem v1.10 Interface for Opus');
  parm;
  read_ctl;
  jm;
end.
